unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLVectorFileObjects, GLTexture, GLScene, GLObjects, GLMisc,
  GLWin32Viewer, glFile3ds, GLCadencer, math, GLWin32FullScreenViewer,
  GLGeomObjects, GLShadowVolume, vectorGeometry, GLNewtonManager, ExtCtrls,
  vectorTypes, GLSkyBox, GLBitmapFont, GLWindowsFont, GLHUDObjects, newtonimport,
  ImgList;

type
  TGameMode = (gmIntro, gmPlaying);

  TdtmMain = class(TDataModule)
    glFontObject2: TGLWindowsBitmapFont;
    GLNewtonManager1: TGLNewtonManager;
    GLFullScreenViewer1: TGLFullScreenViewer;
    glFontObject1: TGLWindowsBitmapFont;
    GLScene: TGLScene;
    glProxyCastle2: TGLProxyObject;
    glProxyCast1: TGLProxyObject;
    GLPlaneFront: TGLPlane;
    glPlaneLeft: TGLPlane;
    glPlaneRight: TGLPlane;
    glPlaneBottom: TGLPlane;
    glPlaneBack: TGLPlane;
    glGameCube: TGLDummyCube;
    glTextTeaChests: TGLHUDText;
    glSunSphere: TGLSphere;
    glLightSun: TGLLightSource;
    glFLandMass: TGLFrustrum;
    glTargetCylinder: TGLCylinder;
    glGameSocket: TGLDummyCube;
    GLCamera: TGLCamera;
    GLLightSource: TGLLightSource;
    GLShadowVolume: TGLShadowVolume;
    glffFlower: TGLFreeForm;
    glFloor: TGLPlane;
    GLSphere1: TGLSphere;
    glTextSafes: TGLHUDText;
    glTextJukeboxes: TGLHUDText;
    glTimerText: TGLHUDText;
    glTextLevel: TGLHUDText;
    glIntroCube: TGLDummyCube;
    glIntro3: TGLHUDText;
    glIntro2: TGLHUDText;
    glIntro1: TGLHUDText;
    glffCastle: TGLFreeForm;
    glffTown: TGLFreeForm;
    GLCube1: TGLCube;
    glIntroCameraSocket: TGLDummyCube;
    GLProxyObject1: TGLProxyObject;
    glIntro4: TGLHUDText;
    GLProxyObject2: TGLProxyObject;
    GLProxyObject3: TGLProxyObject;
    GLHUDSprite: TGLHUDSprite;
    ImageList1: TImageList;
    GLMaterialLibrary: TGLMaterialLibrary;
    Timer1: TTimer;
    tmrTimer: TTimer;
    GLCadencer1: TGLCadencer;
    procedure DataModuleCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure GLCadencer1Progress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure tmrTimerTimer(Sender: TObject);
    procedure GLFullScreenViewer1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GLFullScreenViewer1MouseWheel(Sender: TObject;
      Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
      var Handled: Boolean);
    procedure GLFullScreenViewer1MouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    function createLevel2Object : TGLDummyCube;
    procedure addJukebox;
    procedure addSafe;
    procedure addTeaChest;
  public
    { Public declarations }
    pick : TGLBaseSceneObject;
    gameMode :TGameMode;
    cameraDistance : real;
    mx, mz : real;
    mousex, mousey : integer;
    inShadow : boolean;
    originalCameraSocket : TGLBaseSceneObject;
    moving : boolean;
    objectCount : integer;
    shiftDown : boolean;
    safesLeft, teachestsleft, jukeboxesleft : integer;
    currentLevel : integer;
    timeLeft : integer;
    shadowTime : integer;
    currentComment : integer;
    showingComment : boolean;
    procedure showComment(comment : integer);
    procedure hideComment;
    procedure newGame;
    procedure endGame;
    procedure startLevel;
    procedure changeMode(newMode : TGameMode);
    function checkShadow : boolean;
    procedure clearLevel;
    procedure deleteItem;
    procedure updateCounts;
  end;

var
  dtmMain: TdtmMain;

implementation

uses Unit2;

{$R *.dfm}

procedure TdtmMain.showComment(comment : integer);
begin
  currentComment := comment;
  dtmComments.addComment(currentComment);
  GLHUDSprite.Visible := true;
  GLHUDSprite.Material.Texture.Image.Assign(dtmComments.backgroundimage);
  GLHUDSprite.Material.Texture.Image.NotifyChange(self);
  showingComment := true;
  GLCadencer1.Enabled := false;
end;

procedure TdtmMain.hideComment;
begin
  if dtmComments.checkForNextComments(currentComment) <> 0 then
    showComment(dtmComments.checkForNextComments(currentComment))
  else begin
    showingComment := false;
    GLHUDSprite.Visible := false;
    GLCadencer1.Enabled := true;
  end;
end;

procedure TdtmMain.newGame;
begin
  currentLevel := 0;
  showComment(3); //3
  startLevel;

end;

procedure TdtmMain.endGame;
begin
  changeMode(gmIntro);
end;

procedure TdtmMain.startLevel;
begin
 // cameraDistance := 30;
  //glGameSocket.TurnAngle := 0;
  //glCamera.Position.SetPoint(0,cameraDistance,cameraDistance);

  clearLevel;
  timeLeft := 10;//5*60;
  case currentLevel of
    0 : begin
      glffFlower.Position.Y := 5;
      teachestsleft := 15;
      safesleft := 10;
      jukeboxesleft := 0;
    end;
    1 : begin
      showComment(5);
      glffFlower.Position.Y := 7;
      teachestsleft := 10;
      safesleft := 15;
      jukeboxesleft := 0;
    end;
    2 : begin
      showComment(6);
      glffFlower.Position.Y := 9;
      teachestsleft := 5;
      safesleft := 20;
      jukeboxesleft := 3;
    end;
    3 : begin
      showComment(7);
    end;
  end;
  updateCounts;
end;

procedure TdtmMain.addTeaChest;
var tempCube : TGLFreeForm;
var newtonDynamic : TNewtonElementBox;
var tempFreeForm : TGLFreeForm;
var b : TGLNewtonDynamic;
var e : TNewtonElementFreeForm;
var box : TNewtonElementBox;
begin
  if teachestsleft > 0 then begin
    dec(teachestsleft);
    updateCounts;
    tempCube := TGLFreeForm.CreateAsChild(GLShadowVolume);
    tempCube.position.X := mx+random(10)/10-0.5;
    tempCube.position.z := mz+random(10)/10-0.5;
    tempCube.position.y := 14;
    //tempCube.Scale.SetVector(2,2,2);
    tempCube.turnangle := random(360);
    glShadowVolume.Occluders.AddCaster(tempCube);
    tempCube.LoadFromFile('./models/teachest.3ds');
    tempCube.Material.MaterialLibrary := GLMaterialLibrary;
    tempCube.Material.LibMaterialName := 'teachestmaterial';

    newtonDynamic := TNewtonElementBox(TGLNewtonDynamic(tempCube.Behaviours.GetOrCreate(TGLNewtonDynamic)).Elements.GetOrCreate(TNewtonElementBox));
    newtonDynamic.BoxWidth := 1.5;
    newtonDynamic.BoxHeight := 1.5;
    newtonDynamic.BoxDepth := 1.5;

    TGLNewtonDynamic(tempCube.Behaviours.GetOrCreate(TGLNewtonDynamic)).Manager := GLNewtonManager1;
  end;
end;

procedure TdtmMain.addJukebox;
var tempCube : TGLFreeForm;
var newtonDynamic : TNewtonElementBase;
var tempFreeForm : TGLFreeForm;
var b : TGLNewtonDynamic;
var e : TNewtonElementFreeForm;
begin

  if jukeboxesleft > 0 then begin
    dec(jukeboxesleft);
    updateCounts;
    tempCube := TGLFreeform.CreateAsChild(GLShadowVolume);
    tempCube.position.X := mx;
    tempCube.position.z := mz;
    tempCube.position.y := 10;
    tempCube.turnangle := random(360);
    glShadowVolume.Occluders.AddCaster(tempCube);
    tempCube.LoadFromFile('./models/jukebox.3ds');
    tempCube.Material.MaterialLibrary := GLMaterialLibrary;
    tempCube.Material.LibMaterialName := 'jukeboxmaterial';

    TNewtonElementFreeForm(TGLNewtonDynamic(tempCube.Behaviours.GetOrCreate(TGLNewtonDynamic)).Elements.GetOrCreate(TNewtonElementFreeForm)).FreeForm := tempCube;
    TGLNewtonDynamic(tempCube.Behaviours.GetOrCreate(TGLNewtonDynamic)).Manager := GLNewtonManager1;

//  tempCube := TGLFreeForm.CreateAsChild(objectCube);
  //tempCube.LoadFromFile('./models/teachest.3ds');
  //tempCube.Material.MaterialLibrary := GLMaterialLibrary;
  //tempCube.Material.LibMaterialName := 'teachestmaterial';
end;
end;

procedure TdtmMain.addSafe;
var tempCube : TGLFreeForm;
var newtonDynamic : TNewtonElementBox;
var tempFreeForm : TGLFreeForm;
var b : TGLNewtonDynamic;
var e : TNewtonElementFreeForm;
begin
  if safesLeft > 0 then begin
    dec(safesLeft);
    updateCounts;
    tempCube := TGLFreeForm.CreateAsChild(GLShadowVolume);
    tempCube.position.X := mx;
    tempCube.position.z := mz;
    tempCube.position.y := 14;
    tempCube.turnangle := random(360);
    glShadowVolume.Occluders.AddCaster(tempCube);
    tempCube.LoadFromFile('./models/safe.3ds');
    tempCube.Material.MaterialLibrary := GLMaterialLibrary;
    tempCube.Material.LibMaterialName := 'safematerial';

    newtonDynamic := TNewtonElementBox(TGLNewtonDynamic(tempCube.Behaviours.GetOrCreate(TGLNewtonDynamic)).Elements.GetOrCreate(TNewtonElementBox));
    newtonDynamic.Mass := 5;
    TGLNewtonDynamic(tempCube.Behaviours.GetOrCreate(TGLNewtonDynamic)).Manager := GLNewtonManager1;
  end;
end;

function TdtmMain.createLevel2Object : TGLDummyCube;
var tempCube : TGLFreeForm;
var objectCube : TGLDummyCube;
var newtonDynamic : TNewtonElementSphere;
var tempFreeForm : TGLFreeForm;
var b : TGLNewtonDynamic;
var e : TNewtonElementFreeForm;
begin
  objectCube := TGLDummyCube.CreateAsChild(GLShadowVolume);
  objectCube.position.X := mx;
  objectCube.position.z := mz;
  objectCube.position.y := 10;
  glShadowVolume.Occluders.AddCaster(objectCube);

  //TGLNewtonDynamic(objectCube.Behaviours.GetOrCreate(TGLNewtonDynamic)).AddNewElement(TNewtonElementBox);
  TGLNewtonDynamic(objectCube.Behaviours.GetOrCreate(TGLNewtonDynamic)).Elements.GetOrCreate(TNewtonElementBox);
 // newtonDynamic := TNewtonElementSphere(TGLNewtonDynamic(objectCube.Behaviours.GetOrCreate(TGLNewtonDynamic)).AddNewElement(TNewtonElementSphere));
 // newtonDynamic.Position.Y := -3;
  TGLNewtonDynamic(objectCube.Behaviours.GetOrCreate(TGLNewtonDynamic)).Manager := GLNewtonManager1;


  tempCube := TGLFreeForm.CreateAsChild(objectCube);
  tempCube.LoadFromFile('./models/jukebox.3ds');
  tempCube.Material.MaterialLibrary := GLMaterialLibrary;
  tempCube.Material.LibMaterialName := 'jukeboxmaterial';

end;

procedure TdtmMain.changeMode(newMode : TGameMode);
begin
  gameMode := newMode;
  case gameMode of
    gmIntro : begin
      cameraDistance := 100;
      glCamera.Position.y := 30;
      glCamera.TargetObject := glffCastle;
      glIntroCube.Visible := true;
      glGameCube.Visible := false;
      glCamera.Parent := glGameSocket;
      moving := true;
      tmrTimer.enabled := false;
//      glGameSocket.AddChild(glCamera);
    end;
    gmPlaying : begin
      glIntroCameraSocket.TurnAngle := 0;
      cameraDistance := 100;
      glCamera.Position.SetPoint(0,15,cameraDistance);
      glCamera.TargetObject := glFLandMass;
      glIntroCube.Visible := false;
      glGameCube.Visible := true;
      glCamera.Parent := glIntroCameraSocket;
      moving := true;
      newGame;
//      glIntroCameraSocket.AddChild(glCamera);
    end;
  end;
end;

procedure TdtmMain.DataModuleCreate(Sender: TObject);
begin
 glffCastle.LoadFromFile('./models/island.3ds');
 glffFlower.LoadFromFile('./models/flower.3ds');
  glffTown.LoadFromFile('./models/town.3ds');
  changeMode(gmIntro);
  GLFullScreenViewer1.active := true;
  while GLFullScreenViewer1.active do
    application.processmessages;
end;

procedure TdtmMain.Timer1Timer(Sender: TObject);
var prevInShadow : boolean;
begin
  prevInShadow := inShadow;
  inShadow := checkShadow;
  if inShadow and not prevInShadow then
    shadowTime := 0;

end;

procedure TdtmMain.GLCadencer1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
begin
  case gameMode of
    gmIntro : begin
      glffCastle.turn(deltaTime*5);
      if moving then begin
        cameraDistance := cameraDistance - deltaTime*4;
        if cameraDistance < 30 then begin
          cameraDistance := 30;
          moving := false;
        end;
      end;  
      glCamera.Position.X := -cameraDistance;
      glCamera.Position.z := cameraDistance;
    end;
    gmPlaying : begin
      GLNewtonManager1.Step(deltaTime);
      if moving then begin
        cameraDistance := cameraDistance - deltaTime*32;
        if cameraDistance < 15 then begin
          cameraDistance := 15;
          moving := false;
          tmrTimer.enabled := true;
        end;
      end;
      // glCamera.Position.X := -cameraDistance;
      glCamera.Position.z := cameraDistance;
      if inShadow then
        glffFlower.Roll(deltaTime*32);
    end;
  end;
end;

procedure TdtmMain.tmrTimerTimer(Sender: TObject);
begin
  if timeLEft > 0 then begin
    dec(timeLeft);
    glTimerText.Text := 'Seconds left : ' + intToStr(timeLEft);

    if timeLeft <=0 then
      endGame

    else if inShadow then begin
      inc(shadowTime);
      if shadowTime >= 5 then begin
        inc(CurrentLevel);
        startLevel;
      end;
    end;
  end else 
    showComment(9);
end;

procedure TdtmMain.GLFullScreenViewer1KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var force, Pos: TVector3f;
begin
  if key = vk_escape then
    GLFullScreenViewer1.active := false
  else if showingComment then begin
    hideComment
  end else
    if gameMode = gmIntro then begin
      if key = 73 then
        showComment(0)
      else
        changeMode(gmPlaying)
    end else begin
      if key = 65 then begin
        glSphere1.position.x := glSphere1.position.x-1;
        TNewtonElementBase(TGLNewtonDynamic(glSphere1.Behaviours[0]).Elements[0]).Position.x :=glSphere1.position.x;
      end else if key = 83 then
        clearLevel
      else if key = 49 then
        addTeachest
      else if key = 50 then
        addSafe
      else if key = 51 then
        addJukebox
      else if key = 46 then
        deleteItem;
    end;

end;

procedure TdtmMain.clearLevel;
var count : integer;
var pick : TGLBaseSceneObject;
var newtonDynamic : TNewtonElementBase;
begin
  for count := GLShadowVolume.Count -1 downto 0 do begin
    pick := GLShadowVolume.Children[count];
    if (pick is TGLFreeForm) and (pick.Parent = GLShadowVolume) and (pick.Behaviours.Count > 0) then begin
    //  NewtonDestroyBody(TGLNewtonBehaviour(newtonDynamic.Owner.Owner).Manager.World,newtonDynamic.Body);
      newtonDynamic := TNewtonElementBase(TGLNewtonDynamic(pick.Behaviours.GetOrCreate(TGLNewtonDynamic)).Elements.GetOrCreate(TNewtonElementBase));
      NewtonDestroyBody(TGLNewtonBehaviour(newtonDynamic.Owner.Owner).Manager.World,newtonDynamic.Body);
      //TGLNewtonDynamic(pick.Behaviours.GetOrCreate(TGLNewtonDynamic)).Manager := nil;
      GLShadowVolume.Remove(pick,false);
    end;
  end;
end;

function TdtmMain.checkShadow : boolean;
var rayStart, rayVector, iPoint, iNormal : TVector;
var base : TGLBaseSceneObject;
begin
  SetVector(rayStart, glSunSphere.AbsolutePosition);
  SetVector(rayVector, glffFlower.position.x - glSunSphere.position.x,
    glffFlower.position.y - glSunSphere.position.y, glffFlower.position.z - glSunSphere.position.z);
  NormalizeVector(rayVector);
  // Here we request RayCast intersection
  glSunSphere.Visible := false;
  glFLandMass.Visible := false;
  base := glScene.RayCastIntersect(rayStart,rayVector,@iPoint, @iNormal);
  //caption := TGLFreeForm(base).name;
  result := (base <> TGLBaseSceneObject(glffFlower)) and (base <> TGLBaseSceneObject(glTargetCylinder));
  glFLandMass.Visible := true;
  glSunSphere.Visible := true;
  //inShadow := glffFlower.RayCastIntersect(rayStart, rayVector, @iPoint, @iNormal);
end;

procedure TdtmMain.GLFullScreenViewer1MouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
  if not moving then begin
    if ssShift in shift then begin
      cameraDistance := cameraDistance + wheelDelta/20;
      glCamera.Position.SetPoint(0,cameraDistance,cameraDistance);
    end else
      glIntroCameraSocket.Turn(wheelDelta/10);
  end;    
end;

procedure TdtmMain.updateCounts;
begin
  glTextSafes.text := 'Safes left : '+intToStr(safesLeft);
  glTextTeachests.text := 'Teachests left : '+intToStr(teachestsleft);
  glTextJukeboxes.text := 'Jukeboxes left : '+intToStr(jukeboxesleft);
  glTextLevel.Text := 'Current level : '+intToStr(currentLevel);
end;

procedure TdtmMain.deleteItem;
var pick : TGLBaseSceneObject;
var newtonDynamic : TNewtonElementBase;
begin
  pick:=(GLFullScreenViewer1.Buffer.GetPickedObject(mousex, mousey) as TGLBaseSceneObject);
  if (pick <> nil) and (pick is TGLFreeForm) and (pick.Parent = GLShadowVolume) and (pick.Behaviours.Count > 0)then begin

    if TGLFreeForm(pick).Material.LibMaterialName = 'teachestmaterial' then
      inc(teachestsleft)
    else if TGLFreeForm(pick).Material.LibMaterialName = 'jukeboxmaterial' then
      inc(jukeboxesleft)
    else
      inc(safesLeft);
    updateCounts;  

    newtonDynamic := TNewtonElementBase(TGLNewtonDynamic(pick.Behaviours.GetOrCreate(TGLNewtonDynamic)).Elements.GetOrCreate(TNewtonElementBase));
    NewtonDestroyBody(TGLNewtonBehaviour(newtonDynamic.Owner.Owner).Manager.World,newtonDynamic.Body);
    //TGLNewtonDynamic(pick.Behaviours.GetOrCreate(TGLNewtonDynamic)).Manager := nil;
    GLShadowVolume.Remove(pick,false);
   // pick.Behaviours.delete(0);
  end;
end;

procedure TdtmMain.GLFullScreenViewer1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var rayStart, rayVector, iPoint, iNormal : TVector;
begin
//  pick:=(GLSceneViewer1.Buffer.GetPickedObject(x, GLSceneViewer1.Height-y) as TGLBaseSceneObject);

  mousex := x;
  mousey := y;

  SetVector(rayStart, GLCamera.AbsolutePosition);
  SetVector(rayVector, GLFullScreenViewer1.Buffer.ScreenToVector(AffineVectorMake(x, GLFullScreenViewer1.Height-y, 0)));
  NormalizeVector(rayVector);
  // Here we request RayCast intersection
  if glFloor.RayCastIntersect(rayStart, rayVector, @iPoint, @iNormal) then begin
    mx := ipoint[0];
    mz := ipoint[2];
    glTargetCylinder.Position.X := mx;
    glTargetCylinder.Position.z := mz;
    glTargetCylinder.visible := true;
  end else begin
    mx := -1;
    mz := -1;
    glTargetCylinder.visible := false;
  end;
end;

end.
